Subject: IPv6 Service Discovery

From: "Abhijit Chaudhary \(abchaudh\)" <[email-masked]>
Date: Thu, 4 Aug 2005 10:52:50 +0530

Hi,
I have question regarding IPv6 auto service discovery. 
 
Suppose a IPv6 Mobile Host comes and joins a network. Using Stateful or
Stateless Address Configuration mentioned in ICMPv6 Router
Advertisement message it gets a IPv6 address. 
But if the mobile host want to know the nearest printer IP address or
the proxy address or DNS server address (i.e, IP address of Responder
mentioned in draft-ietf-ipngwg-icmp-name-lookups-12.txt).
Is there any draft or RFC that talks about a procedure to get
information about Server providing application Service for IPv6?
 
If not, I am of the impression that we can add a new option to Router
Advertisement message called "Application Service Discovery Proxy". This
option will contain the IPv6 address and Link-Layer address of the
"Application Service Discovery Proxy". This proxy will contain all the
information of the available application service in the network and the
corresponding servers. The new option will look as below:
 
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |     Type         |    Length             |            Reserved
|  
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |           IPv6 Address of Application  Service Discovery Proxy
|
      +
|
      |  +++++++++++++++++++++++++++++++++++++++++++++++ |

      ~         Link-Layer Address of  Service Discovery Proxy
|   
      |
|
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 
The Message Exchange is described below:
 
1) Router Advertisement will contain the Application Service Discovery
Proxy Option
                                  "Router Advertisement with Application
Service Discovery Proxy Option"
                 Router
------------------------------------------------------------------------
---------------------------------------------------------> Host
 
2) Host gets the Address of the Application Service Discovery Proxy and
stores it. Suppose, the host wants printing service, it uses some
protocol (maybe UDP or XML over HTTP or ICMPv6) to discover services
from the Application Service Discovery Proxy.
    For Printing service the message as below:
                                        "Give me printer service
address" 
           1.     Host
------------------------------------------------------------------------
---------------->  Application Service Discovery Proxy 

"Printer IPv6 address = x, Printer LL address = y"
           2.     Application Service Discovery Proxy
------------------------------------------------------------------------
---------------------------> Host
 
                                           "Sends data to be printed" 
           3.     Host
----------------------------------------------------------------------->
Printer
 
Let me know what you guys feel about it.
 
Thanks,
- Abhijit
--------------------------------------------------------------------
IETF IPv6 working group mailing list
[email-masked]
Administrative Requests: https://www1.ietf.org/mailman/listinfo/ipv6
--------------------------------------------------------------------

---

From: Mark Smith <[email-masked]>
Date: Thu, 4 Aug 2005 15:13:39 +0930

Hi Abhijit,

I don't know all that much about how it operates however, I think that
is what "SLP - Service Location Protocol" is designed for. From RFC2608
-

"  The Service Location Protocol provides a scalable framework for the
   discovery and selection of network services.  Using this protocol,
   computers using the Internet need little or no static configuration
   of network services for network based applications.  This is
   especially important as computers become more portable, and users
   less tolerant or able to fulfill the demands of network system
   administration."

I don't know enough about it to say whether it allows for or needs to be
updated to support IPv6.

On a related note, I'd be curious to know if anybody is updating NetBIOS
over IP / CIFS to support IPv6. I'd think that NetBIOS / CIFS file and
print sharing probably carries more data on a daily basis than any other
IPv4 carried protocol. Maybe that is one cause for people not
introducing IPv6 to their enterprise networks - their most commonly used
application protocol isn't supported over it.

Regards,
Mark.

---

From: JORDI PALET MARTINEZ <[email-masked]>
Date: Thu, 04 Aug 2005 08:51:31 +0200

Hi,

In my opinion SLP has some issues to be deployed, at least it has for our
case when we worked in Tunnel End Point discovery (see section 3.5).
http://www.ietf.org/internet-drafts/draft-palet-v6ops-tun-auto-disc-03.txt

A more complete version is available at
http://www.consulintel.euro6ix.org/ietf/draft-palet-v6ops-tun-auto-disc-pre-
03.txt

Also, a possible solution:
http://www.consulintel.euro6ix.org/ietf/draft-palet-v6ops-solution-tun-auto-
disc-01.txt

I think that we worked out for TEP discovery could also be applicable for
the discovery of other services.

Regards,
Jordi

> De: Mark Smith <[email-masked]>
> Responder a: <[email-masked]>
> Fecha: Thu, 4 Aug 2005 15:13:39 +0930
> Para: "Abhijit Chaudhary (abchaudh)" <[email-masked]>
> CC: "[email-masked]" <[email-masked]>
> Asunto: Re: IPv6 Service Discovery
> 
> Hi Abhijit,
> 

************************************
The IPv6 Portal: http://www.ipv6tf.org

Barcelona 2005 Global IPv6 Summit
Information available at:
http://www.ipv6-es.com

This electronic message contains information which may be privileged or confidential. The information is intended to be for the use of the individual(s) named above. If you are not the intended recipient be aware that any disclosure, copying, distribution or use of the contents of this information, including attached files, is prohibited.

---

From: "James Kempf" <[email-masked]>
Date: Wed, 3 Aug 2005 23:48:57 -0700

Check RFC 3111. Unfortunately, SLP hasn't been very widely used, though there are a few very specific cases where it has been (iSCSI discovery, SIP proxy discovery, among others).

I would not be in favor of extending the RA for this purpose in any case. LW DHCP is a better choice and has better possibility for wider deployment, though somewhat more constrained than SLP in how services are defined.

            jak

  ----- Original Message ----- 
  From: Abhijit Chaudhary (abchaudh) 
  To: [email-masked] 
  Sent: Wednesday, August 03, 2005 10:22 PM
  Subject: IPv6 Service Discovery

  Hi,

  Suppose a IPv6 Mobile Host comes and joins a network. Using Stateful or Stateless Address Configuration mentioned in ICMPv6 Router  Advertisement message it gets a IPv6 address. 
  But if the mobile host want to know the nearest printer IP address or the proxy address or DNS server address (i.e, IP address of Responder  mentioned in draft-ietf-ipngwg-icmp-name-lookups-12.txt).
  Is there any draft or RFC that talks about a procedure to get information about Server providing application Service for IPv6?

  If not, I am of the impression that we can add a new option to Router  Advertisement message called "Application Service Discovery Proxy". This option will contain the IPv6 address and Link-Layer address of the "Application Service Discovery Proxy". This proxy will contain all the information of the available application service in the network and the corresponding servers. The new option will look as below:

        +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
        |     Type         |    Length             |            Reserved                      |  
        +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
        |           IPv6 Address of Application  Service Discovery Proxy         |
        +                                                                                               |
        |  +++++++++++++++++++++++++++++++++++++++++++++++ |                                                             
        ~         Link-Layer Address of  Service Discovery Proxy                  |   
        |                                                                                                 |
        +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

  1) Router Advertisement will contain the Application Service Discovery Proxy Option
                                    "Router Advertisement with Application Service Discovery Proxy Option"
                   Router  ---------------------------------------------------------------------------------------------------------------------------------> Host

  2) Host gets the Address of the Application Service Discovery Proxy and stores it. Suppose, the host wants printing service, it uses some protocol (maybe UDP or XML over HTTP or ICMPv6) to discover services from the Application Service Discovery Proxy.
      For Printing service the message as below:
                                          "Give me printer service address" 
             1.     Host ---------------------------------------------------------------------------------------->  Application Service Discovery Proxy 

                                                                                 "Printer IPv6 address = x, Printer LL address = y"
             2.     Application Service Discovery Proxy ---------------------------------------------------------------------------------------------------> Host

                                             "Sends data to be printed" 
             3.     Host -----------------------------------------------------------------------> Printer

  Thanks,
  - Abhijit

------------------------------------------------------------------------------

---

From: Perry Lorier <[email-masked]>
Date: Thu, 04 Aug 2005 19:22:03 +1200

> information about Server providing application Service for IPv6?

I would have thought it would use DNS Service Discovery/Multicast DNS.

http://www.multicastdns.org/
http://www.dns-sd.org/

While these protocols are mostly used under IPv4, I forsee[1] no reason
why they shouldn't work in a mixed v6/v6 only network without change.
They are well deployed already by being built into MacOS X, and some
other platforms.

[1]: I've not carefully studied these protocols however, so I suggest
you consult others before declaring that these are ready for v6.

---

From: Iljitsch van Beijnum <[email-masked]>
Date: Thu, 4 Aug 2005 13:55:19 +0200

> They are well deployed already by being built into MacOS X, and some

Apple implements this as Bonjour (formerly Rendezvous), and see  
http://www.zeroconf.org/

I've seen Bonjour/Rendezvous work over IPv6 without trouble, but  
sometimes the availability of different ways to do the same thing (v4 
+v6, wireless/ether) complicates things a bit.

The use of multicast DNS, or possibly dynamic DNS, is more  
appropriate for discovering services than DHCP or RA, because it  
allows hosts offering services to advertise those services  
autonomously rather than requiring an admin to add them to the DHCP  
server or router. (Or having to implement complex new mechanisms to  
make this happen automatically.)